package com.fp.frontend.controller.pcustomer.lov;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.primefaces.context.RequestContext;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.query.Filter;
import com.fp.dto.query.SubQuery;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.pgeneral.gene.ParametersController;
import com.fp.frontend.enums.EnumLovOption;
import com.fp.frontend.helper.CallerHelper;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pcustomer.gene.TcustPersonDetail;
import com.fp.persistence.pgeneral.gene.TgeneParameters;

/**
 * Clase controladora del lov asociado al bean TsafeUserDetail.
 *
 * @author Jorge Vaca.
 * @version 2.1
 */
@ManagedBean
@ViewScoped
public class PersonLovController extends AbstractController<TcustPersonDetail> {

    private static final long serialVersionUID = 1L;

    public PersonLovController() throws Exception {
        super(TcustPersonDetail.class);
    }

    @PostConstruct
    private void postconstruct() throws Exception {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }
    /**
     * codigo del telefono fijo
     */
    private String codigoTelefonoFijo;
    String natural;

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    public void init() {
        try {
            this.recperpage = 15; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "PERSONLOV";
            codigoTelefonoFijo = codigos("CODIGO.PHONE.FIJO");
            natural = CallerHelper.getLovParameter("natural");
//			if(natural!=null){        	
//				this.getMfilters().put("identificationcatalog", natural);
//			}
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    public void querydatabaseFiltro(String documento) {
        try {
//            if (!super.existAtLeastOneFilterValue()) {
//                MessageHelper.setMessageError("msg_filterrequird");
//                return;
//            }
            super.addFilterDateto();
            // super.addFilter("identificationcatalog", documento);
            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.name");

            SubQuery subqueryTipoIdentificacion = new SubQuery("TgeneCatalogDetail", "description", "destipoidentificacion", "i.pk.catalog = t.identificationcatalog and  i.pk.catalogcode=t.identificationcatalogcode");
            dto.addSubQuery(subqueryTipoIdentificacion);

            SubQuery subqueryTelefono = new SubQuery("TcustPersonPhone", "phonenumber", "telefono", "i.pk.personcode = t.pk.personcode and  i.pk.dateto=t.pk.dateto and i.phonetypecatalog='" + codigoTelefonoFijo + "' and i.pk.phonesequence = (select max(b.pk.phonesequence) from TcustPersonPhone b where b.pk.personcode = t.pk.personcode and b.phonetypecatalog = '" + codigoTelefonoFijo + "')");
            dto.addSubQuery(subqueryTelefono);

            if (natural != null) {
                Filter filter = new Filter();
                filter.setSql(" (t.identificationcatalog='CED' or t.identificationcatalog='PAS') ");
                dto.addFiltro(filter);
            }

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TcustPersonDetail>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TcustPersonDetail>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
//            if (!super.existAtLeastOneFilterValue()) {
//                MessageHelper.setMessageError("msg_filterrequird");
//                return;
//            }
            super.addFilterDateto();
            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.name");

            SubQuery subqueryTipoIdentificacion = new SubQuery("TgeneCatalogDetail", "description", "destipoidentificacion", "i.pk.catalog = t.identificationcatalog and  i.pk.catalogcode=t.identificationcatalogcode");
            dto.addSubQuery(subqueryTipoIdentificacion);

            SubQuery subqueryTelefono = new SubQuery("TcustPersonPhone", "phonenumber", "telefono", "i.pk.personcode = t.pk.personcode and  i.pk.dateto=t.pk.dateto and i.phonetypecatalog='" + codigoTelefonoFijo + "' and i.pk.phonesequence = (select max(b.pk.phonesequence) from TcustPersonPhone b where b.pk.personcode = t.pk.personcode and b.phonetypecatalog = '" + codigoTelefonoFijo + "')");
            dto.addSubQuery(subqueryTelefono);

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TcustPersonDetail>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TcustPersonDetail>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public void setperson() {
        // se utiliza en la pagina del lov.
        RequestContext.getCurrentInstance().closeDialog(this.record);
    }

    public void setPerson(TcustPersonDetail person) {
        // se utiliza en la pagina del lov.
        RequestContext.getCurrentInstance().closeDialog(person);
    }

    /**
     * Entrega los datos vigentes de una persona dado el codigo de persona.
     *
     * @param personcode
     * @return
     * @throws Exception
     */
    public static TcustPersonDetail find(String personcode) throws Exception {
        PersonLovController p = new PersonLovController();
        p.addFilter("pk.personcode", personcode);
        p.querydatabase();
        List<TcustPersonDetail> l = p.getLrecord();
        if (!l.isEmpty()) {
            return l.get(0);
        }
        return null;
    }

    public static void openLov(Map<String, List<String>> params) {
        Map<String, Object> options = new HashMap<String, Object>();
        // hint: ver EnumLovOption para las opciones del modal
        options.put(EnumLovOption.MODAL.getLabel(), true);
        options.put(EnumLovOption.HEIGHT.getLabel(), 450);
        options.put(EnumLovOption.WIDTH.getLabel(), 700);
        options.put(EnumLovOption.RESIZABLE.getLabel(), true);

        // lovpersona es el nombre de la pagina
        RequestContext.getCurrentInstance().openDialog("/pages/customer/lov/personLov.xhtml", options, params);
    }

    /**
     * Metodo para obtener los codigos
     */
    public String codigos(String parametro) {
        TgeneParameters tgeneParameters = ParametersController.find(parametro, "1");
        return tgeneParameters.getTextvalue();
    }
}
